/*
tuya_iot_config.h
Copyright(C),2018-2020, 涂鸦科技 www.tuya.comm
*/

/* AUTO-GENERATED FILE. DO NOT MODIFY !!!
*
* This config file is automatically generated by tuya cross-build system.
* It should not be modified by hand.
*/

#ifndef TUYA_IOT_CONFIG_H
#define TUYA_IOT_CONFIG_H

#ifdef __cplusplus
extern "C" {
#endif

/* default definitons */

#define SYSTEM_SMALL_MEMORY_BEGIN       0       /*small memory systems begin */
#define SYSTEM_REALTEK8710_1M           1
#define SYSTEM_REALTEK8710_2M           2
#define SYSTEM_NON_OS					3		/*no operating system*/
#define SYSTEM_FREERTOS                 98
#define SYSTEM_SMALL_MEMORY_END         99      /*small memory systems end */
#define SYSTEM_LINUX                    100
#define SYSTEM_LITEOS                   120

#define TLS_DISABLE                     0       /* disable tls function */
#define TLS_TUYA_PSK_ONLY               2       /* only enable ciper 0xAE */
#define TLS_TUYA_ECC_PSK                3       /* enable ciper 0xAE && 0xC027 */
#define TLS_TUYA_ECC_ONLY               4       /* only enable ciper 0xC027 */
#define TLS_TUYA_ECC_ONLY_NOSTRIP       5       /* only enable ciper 0xC027, but enable most of mbed-tls configs */
#define TLS_TUYA_ECC_CLIENT_AUTH        6       /* TLS Client Authentication and Server Authentication mode */

#define TUYA_SL_0           0       /* security level 0,Applies to: Resource-constrained devices;Feature: Can only access Tuya Cloud */
#define TUYA_SL_1           1       /* security level 1,Applies to: Resource-constrained devices;Feature: One-way authentication */
#define TUYA_SL_2           2       /* security level 2,Applies to: Resource-rich equipment;Feature: Two-way authentication */
#define TUYA_SL_3           3       /* security level 3,Applies to: Resource-rich equipment;Feature: Two-way authentication,Devices use security chips to protect sensitive information */
#define TUYA_MODIFY_MBEDTLS             1

#define TUYA_OPERATOR_DISABLE           0x0
#define TUYA_OPERATOR_CUCC              0x01
#define TUYA_OPERATOR_CTCC              0x02
#define TUYA_OPERATOR_CMCC              0x04
#define TUYA_OPERATOR_CMCC_ANDLINK      0x08
#define TUYA_OPERATOR_ALL               (TUYA_OPERATOR_CUCC | TUYA_OPERATOR_CTCC | TUYA_OPERATOR_CMCC)


#define TUYA_LAN_V31              0x1
#define TUYA_LAN_V32              0x2
#define TUYA_LAN_V33              0x4
#define TUYA_LAN_V35              0x8
#define TUYA_LAN_ALL              (TUYA_LAN_V31 | TUYA_LAN_V32 | TUYA_LAN_V33 | TUYA_LAN_V35)

#define TUYA_MQ_V21               0x1
#define TUYA_MQ_V22               0x2
#define TUYA_MQ_V23               0x4
#define TUYA_MQ_ALL               (TUYA_MQ_V21 | TUYA_MQ_V22 | TUYA_MQ_V23)

/* custom settings */
#define BUILD_DATE           "2024_01_03"
#define BUILD_TIME           "14_06_39"
#define GIT_USER             "ci_manage"
#define IOT_SDK_VER          "3.9.0"
#define SDK_BETA_VER         ""
#define TARGET_PLATFORM      "bk7231n"
#define PROJECT_NAME         "tuyaos-iot"
#define SDK_ID               "tuyaos-iot_3.9.0_bk7231n_wifi-ble-com_1.3.5"
// Generated by Tuya (https://www.tuya.com)
// 基于项目 tuyaos-iot (3.9.0-beta.1)
// 基于工具链 bk7231n (0.0.18-beta.32)


#define ENABLE_LOG 1

#define STACK_SIZE_TIMERQ 4096

// CONFIG_ENABLE_PRINTF_CHECK is not set

#define ENABLE_SET_SOCK_OPT 1

#define ENABLE_NETWORK_OPTIONS 1

#define TUYA_FD_MAX_COUNT 64

// CONFIG_DISABLE_BIND_INTERFACE is not set

// CONFIG_ENABLE_VENDOR_PRIVATE_NETSTACK is not set


#define STACK_SIZE_HEALTH_MONITOR 2048

#define HEALTH_FREE_MEM_THRESHOLD 8192

#define ENABLE_OSS_COMPILE_WARNINGS 1

#define ENABLE_LOG_UPLOAD 1

#define PACKET_SIZE_PER_HTTP_SEND 307200

#define HTTP_SEND_INTERVAL 100

#define PACKET_SIZE_PER_LAN_SEND 8192

#define LAN_SEND_INTERVAL 100

#define MAX_UPD_FILE_SIZE 5242880


#define KV_PROTECTED_ENABLE 1

// CONFIG_KV_64BIT_MODE is not set

// CONFIG_ENABLE_KV_FILE is not set

#define ENABLE_KV_PROTECTED 1

#define ENABLE_KV_KEY_SEED 1

#define KV_KEY_SEED "8710_2M"


// CONFIG_ENABLE_UF_HUGE_FILE is not set

#define MAX_LENGTH_OF_FILE_FULL_PATH 128


#define EVENT_NAME_MAX_LEN 16

#define ENABLE_TUYA_LAN 1

#define TUYA_LAN_VERSION 0x8

#define ENABLE_LAN_ENCRYPTION 1

// CONFIG_ENABLE_RTSP_SERVER is not set

#define STACK_SIZE_LAN 4096


#define OTA_DOWMLOAD_BUF_SIZE 1024

#define STACK_SIZE_UPGRADE 4096

// CONFIG_ENABLE_TUYA_DIFF_OTA is not set

// CONFIG_ENABLE_FIRMWARE_SIGN_TUYA is not set

// CONFIG_ENABLE_FIRMWARE_SIGN_USER is not set


// CONFIG_ENABLE_PRODUCT_AUTOTEST is not set

#define STACK_SIZE_MF_TEST 5120

#define ENABLE_LWIP 1

#define LWIP_TCP_HEAD_ALLOC_REUSE_POLL 0

#define LWIP_TUYA_APP_TCPIP_THREAD_SWITCH 1

#define IPEF_TEST_OPTIMIZE 0

#define MEM_SIZE 13312

#define MEMP_NUM_UDP_PCB 6

#define MEMP_NUM_TCP_PCB 10

#define MEMP_NUM_TCP_PCB_LISTEN 5

#define MEMP_NUM_NETCONN 21

#define MEMP_NUM_PBUF 100

#define MEMP_NUM_TCP_SEG 20

#define IP_REASS_MAX_PBUFS 10

#define PBUF_POOL_SIZE 20

#define PBUF_LINK_ENCAPSULATION_HLEN 0

#define TCP_SND_BUF 7300

#define TCP_SND_QUEUELEN 20

#define MEMP_NUM_NETBUF 8

#define TCPIP_MBOX_SIZE 6

#define DEFAULT_UDP_RECVMBOX_SIZE 6

#define DEFAULT_TCP_RECVMBOX_SIZE 6

#define DEFAULT_RAW_RECVMBOX_SIZE 6

#define DEFAULT_ACCEPTMBOX_SIZE 6

#define MEMP_NUM_SYS_TIMEOUT 10

#define LWIP_SO_SNDTIMEO 1

#define LWIP_SO_RCVTIMEO 1

#define LWIP_SO_LINGER 1

#define LWIP_TUYA_SO_LINGER_RST 1

#define LWIP_PROVIDE_ERRNO 1

#define LWIP_IPV6 0

#define LWIP_NETIF_HOSTNAME 1

#define LWIP_TCPIP_CORE_LOCKING 1

#define LWIP_EAPOL_SUPPORT 0

#define TCPIP_THREAD_STACKSIZE 2048

#define TCPIP_THREAD_PRIO 9

#define DHCPC_THREAD_STACKSIZE 2048

#define DHCPC_THREAD_PRIO 5

#define LWIP_TX_PBUF_ZERO_COPY 0

#define CONFIG_TUYA_SOCK_SHIM 0

#define SOCK_API_SYNC 0

#define LWIP_DHCPC_STATIC_IPADDR_ENABLE 0

#define LWIP_NETCONN_SEM_PER_THREAD 1

#define ETHARP_SUPPORT_STATIC_ENTRIES 1

#define LWIP_NETIF_STATUS_CALLBACK 1

#define LWIP_COMPAT_MUTEX_ALLOWED 1

#define LWIP_TIMEVAL_PRIVATE 1

// CONFIG_IN_ADDR_T_DEFINED is not set

#define LWIP_NETCONN_FULLDUPLEX 1

#define MEM_LIBC_MALLOC 0

#define ENABLE_BT_SERVICE 1

#define ENABLE_BT_NETCFG 1

#define ENABLE_BT_ACTIVE 1

#define ENABLE_BT_CTRL 1

#define BT_ADV_INTERVAL_MIN 30

#define BT_ADV_INTERVAL_MAX 60

#define ENABLE_BT_REMOTE_CTRL 1

#define BT_REMOTE_CTRL_SCAN_INTERVAL 30

#define BT_REMOTE_CTRL_SCAN_WINDOWS 10

#define ENABLE_BT_TIMER 1

#define ENABLE_BT_MF 1

// CONFIG_ENABLE_MF_BY_BT is not set

// CONFIG_ENABLE_BT_MESH_NODE is not set

// CONFIG_ENABLE_BT_VIRTUAL is not set

#define TUYA_BLE_VER 4

#define ENABLE_TAL_BLUETOOTH 1

#define TAL_BLUETOOTH 1

#define TAL_BLE_SERVICE_VERSION 2

#define ENABLE_TUYA_BLE_STACK 1

#define TARGET_BT_PLATFORM 3

#define TUYA_HS_BLE_HOST_TASK_PRIORITY 5

#define TUYA_HS_BLE_HOST_STACK_SIZE 3072

#define TY_BT_MOD 1

#define BT_NETCFG 1

#define BT_ACTIVE 1

#define BT_CTRL 1

#define BT_REMOTE_CTRL 1

#define BT_TIMER 1

#define MF_BT 1

// CONFIG_BT_MESH_NODE is not set

// CONFIG_BT_VIRTUAL is not set

// CONFIG_ENABLE_TUYA_RPC is not set

#define WIFI_GW 1

// CONFIG_TUYA_HOSTAPD_SUPPORT is not set

#define ENABLE_WIFI_SERVICE 1

// CONFIG_ENABLE_WIFI_EZ is not set

#define ENABLE_WIFI_AP 1

// CONFIG_ENABLE_WIFI_FFS is not set

// CONFIG_ENABLE_WIFI_PEGASUS is not set

#define ENABLE_WIFI_QRCODE 1

#define ENABLE_WIFI_PROTECT 1

#define ENABLE_WIFI_FFC 1


// CONFIG_TUYA_WIFI_FFC_MASTER is not set

#define TUYA_WIFI_FFC_SLAVER 1

// CONFIG_ENABLE_HOSTAPD is not set

#define ENABLE_STATION_AP_MODE 0

#define WIFI_AP_BUF_SIZE 10240

// CONFIG_QRCODE_ACTIVE_MODE is not set

#define ENABLE_TUYA_CLOUD 1

#define ENABLE_ASTRO_TIMER 1

#define ENABLE_CALENDAR_TIMER 1

// CONFIG_ENABLE_QRCODE_ACTIVE is not set

#define ENABLE_DEVICE_DATA_COLLECT 1

#define ENABLE_LOCAL_KEY_UPDATE 1

#define ENABLE_COMMUNICATE_PRIORITY 1


// CONFIG_ENABLE_BLACK_WHITE_LIST is not set

#define MAX_SECURITY_LEVEL 0

#define TUYA_SECURITY_LEVEL 0

// CONFIG_ENABLE_MBEDTLS_DEBUG is not set

// CONFIG_ENABLE_CUSTOM_CONFIG is not set


#define HTTP_MAX_REQ_RESP_HDR_SIZE 1024

#define MAX_HTTP_SESSION_NUM 16

// CONFIG_ENABLE_HTTP_SESSION is not set


#define TUYA_MQ_VERSION 0x4

#define STACK_SIZE_MQTT_CLIENT 4096

#define QOS1_PUBACK_TIMEOUT 3

#define QOS1_PUBLISH_SLOT_CNT 8

#define QOS1_PUBACK_TIMEOUT_LIMIT 3

#define MAX_RANDOM_DELAY_BEFORE_RECONNECT 300

#define MQTT_HEATBEAT_INTERVAL 60

#define MQTT_RECV_BUF_SIZE 512

#define MQTT_MAX_MESSGAE_SIZE 4096

#define MQTT_RECV_SELECT_TIMEOUT 3000

// CONFIG_ENABLE_MQTT_QOS1_RESEND is not set

// CONFIG_ENABLE_MATOP is not set

#define MATOP_REQ_TIMEOUT 6

#define TUYA_IOT_DEBUG 1


#define STACK_SIZE_WORK_QUEUE 5120

#define MAX_NODE_NUM_WORK_QUEUE 100

#define STACK_SIZE_MSG_QUEUE 4096

#define MAX_NODE_NUM_MSG_QUEUE 100

#define ENABLE_IOT_DEBUG 1

#define MAX_SIZE_OF_DEBUG_BUF 1024

#define ENABLE_LOG_OUTPUT_FORMAT 1

#define TUYA_REDUCE_BIN 2

// CONFIG_ENABLE_WEBSOCKET is not set
// Generated by Tuya (https://www.tuya.com)
// 基于工具链 bk7231n (0.0.100-beta.3)


#define OPERATING_SYSTEM 98

#define LITTLE_END 1

// CONFIG_ENABLE_FILE_SYSTEM is not set

#define ENABLE_RTC 1

#define ENABLE_ADC 1

#define ENABLE_UART 1

// CONFIG_ENABLE_UART_INTERRUPT is not set

#define ENABLE_WATCHDOG 1

#define ENABLE_FLASH 1

#define TUYA_FLASH_TYPE_MAX_PARTITION_NUM 10

#define ENABLE_PWM 1

#define ENABLE_GPIO 1

// CONFIG_ENABLE_I2C is not set

#define ENABLE_SPI 1

// CONFIG_ENABLE_ZIGBEE is not set

#define ENABLE_WIFI 1

// CONFIG_ENABLE_WIRED is not set

#define ENABLE_TIMER 1

// CONFIG_ENABLE_BLUETOOTH is not set

#define ENABLE_HCI 1

// CONFIG_ENABLE_DISPLAY is not set

// CONFIG_ENABLE_MEDIA is not set

// CONFIG_ENABLE_PM is not set

// CONFIG_GPRS_GW is not set

// CONFIG_TUYA_CAT1 is not set

// CONFIG_ENABLE_CELLULAR is not set

// CONFIG_ENABLE_STORAGE is not set

// CONFIG_ENABLE_NB is not set

// CONFIG_ENABLE_REGISTER is not set

// CONFIG_ENABLE_DAC is not set

// CONFIG_ENABLE_I2S is not set

#define ENABLE_PINMUX 1

// CONFIG_ENABLE_PLATFORM_AES is not set

// CONFIG_ENABLE_PLATFORM_SHA256 is not set

// CONFIG_ENABLE_PLATFORM_MD5 is not set

// CONFIG_ENABLE_PLATFORM_SHA1 is not set

// CONFIG_ENABLE_PLATFORM_RSA is not set

// CONFIG_ENABLE_PLATFORM_ECC is not set

// CONFIG_ENABLE_WAKEUP is not set
#define KERNEL_VER "1.0.0"
#ifndef TUYA_LAN_VERSION
#define TUYA_LAN_VERSION TUYA_LAN_V35
#endif

#ifndef TUYA_MQ_VERSION
#define TUYA_MQ_VERSION TUYA_MQ_V23
#endif

#ifndef ENABLE_DEVICE_DATA_COLLECT
#define ENABLE_DEVICE_DATA_COLLECT 0
#endif

#ifndef TUYA_WEAK_ATTRIBUTE
#define TUYA_WEAK_ATTRIBUTE __attribute__ ((weak))
#endif

#ifndef KERNEL_VER
#define KERNEL_VER "9.9.9"
#endif

/* custom settings */

#ifdef __cplusplus
}
#endif


#endif
