#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
# @file get_app_from_cde.py
# @brief 获取品类下的产品名称
# @author huatuo
# @version 1.0.0
# @date 2022-01-10


import os
import sys
import json
import requests
from ruamel import yaml  # pip3 install ruamel.yaml


def get_category_id(make_yaml):
    f = open(make_yaml, "r", encoding="utf-8")
    yaml_res = yaml.load(f.read(), yaml.RoundTripLoader)
    f.close()

    proj_info = yaml_res['info']
    proj_id = proj_info['proj_id']

    return proj_id


def echo_app_name(category_id, cdetoken, out_file):
    cde_api_host = "https://cde-api-cn.tuya-inc.com:7799"  # 线上

    ans = os.popen("embcli cde env")
    cde_env = ans.readline()
    if "daily" in cde_env:
        cde_api_host = "https://cde-open.wgine-daily.com:7799/cde"  # 日常

    cde_url = cde_api_host + "/projects/" + str(category_id) + "/applications"

    headers = {
        "cde-token": cdetoken,
        "Content-Type": "application/json",
    }
    params = {"limit": "999"}

    response = requests.get(cde_url, headers=headers,
                            params=params, verify=False)
    # print(response)
    # print(response.text)

    resp_rst = json.loads(response.text)['result']
    apps_list = [] if resp_rst['count'] == 0 else resp_rst['data']

    app_name_str = ""
    for a in apps_list:
        app_name_str += a['name'] + '\n'

    out_file_dir = os.path.dirname(out_file)
    if not os.path.exists(out_file_dir):
        os.makedirs(out_file_dir)

    with open(out_file, 'w') as f:
        f.write(app_name_str)

    pass


def main():
    yaml_name = sys.argv[1]
    out_file = sys.argv[2]
    cdetoken = sys.argv[3]

    category_id = get_category_id(yaml_name)

    echo_app_name(category_id, cdetoken, out_file)

    pass


if __name__ == '__main__':
    main()
    pass
