/**
 * @file tkl_audio.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 * 
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 * 
 */

// --- BEGIN: user defines and implements ---
#include "tkl_audio.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
* @brief ai init
* 
* @param[in] pconfig: audio config
* @param[in] count: count of pconfig
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_init(TKL_AUDIO_CONFIG_T *pconfig, INT32_T count)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDIO_CONFIG_T *pconfig, INT32_T count);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_init));

    if(fun) {
        ret = fun(pconfig, count);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ai start
* 
* @param[in] card: card number
* @param[in] chn: channel number
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_start(INT32_T card, TKL_AI_CHN_E chn)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AI_CHN_E chn);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_start));

    if(fun) {
        ret = fun(card, chn);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ai set mic volume
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[in] vol: mic volume,[0, 100]
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_set_vol(INT32_T card, TKL_AI_CHN_E chn, INT32_T vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AI_CHN_E chn, INT32_T vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_set_vol));

    if(fun) {
        ret = fun(card, chn, vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ai get frame
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[out] pframe: audio frame, pframe->pbuf allocated by upper layer application
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_get_frame(INT32_T card, TKL_AI_CHN_E chn, TKL_AUDIO_FRAME_INFO_T *pframe)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AI_CHN_E chn, TKL_AUDIO_FRAME_INFO_T *pframe);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_get_frame));

    if(fun) {
        ret = fun(card, chn, pframe);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ai stop
* 
* @param[in] card: card number
* @param[in] chn: channel number
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_stop(INT32_T card, TKL_AI_CHN_E chn)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AI_CHN_E chn);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_stop));

    if(fun) {
        ret = fun(card, chn);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ai uninit
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_uninit(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_uninit));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao init
* 
* @param[in] pconfig: audio config
* @param[in] count: config count
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_init(TKL_AUDIO_CONFIG_T *pconfig, INT32_T count, VOID **handle)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDIO_CONFIG_T *pconfig, INT32_T count, VOID **handle);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_init));

    if(fun) {
        ret = fun(pconfig, count, handle);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao start
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[out] handle: handle of start
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_start(INT32_T card, TKL_AO_CHN_E chn, VOID *handle)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AO_CHN_E chn, VOID *handle);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_start));

    if(fun) {
        ret = fun(card, chn, handle);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao set volume
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[in] vol: mic volume,[0, 100]
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_set_vol(INT32_T card, TKL_AO_CHN_E chn, VOID *handle, INT32_T vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AO_CHN_E chn, VOID *handle, INT32_T vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_set_vol));

    if(fun) {
        ret = fun(card, chn, handle, vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao get volume
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[in] vol: mic volume,[0, 100]
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_get_vol(INT32_T card, TKL_AO_CHN_E chn, VOID *handle, INT32_T *vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AO_CHN_E chn, VOID *handle, INT32_T *vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_get_vol));

    if(fun) {
        ret = fun(card, chn, handle, vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao output frame
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[in] handle: handle of start
* @param[in] pframe: output frame
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_put_frame(INT32_T card, TKL_AO_CHN_E chn, VOID *handle, TKL_AUDIO_FRAME_INFO_T *pframe)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AO_CHN_E chn, VOID *handle, TKL_AUDIO_FRAME_INFO_T *pframe);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_put_frame));

    if(fun) {
        ret = fun(card, chn, handle, pframe);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao stop
* 
* @param[in] card: card number
* @param[in] chn: channel number
* @param[in] handle: handle of start
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_stop(INT32_T card, TKL_AO_CHN_E chn, VOID *handle)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_AO_CHN_E chn, VOID *handle);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_stop));

    if(fun) {
        ret = fun(card, chn, handle);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief ao uninit
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ao_uninit(VOID *handle)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID *handle);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ao_uninit));

    if(fun) {
        ret = fun(handle);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief audio input detect start
* 
* @param[in] card: card number
* @param[in] type: detect type
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_detect_start(INT32_T card, TKL_MEDIA_DETECT_TYPE_E type)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_MEDIA_DETECT_TYPE_E type);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_detect_start));

    if(fun) {
        ret = fun(card, type);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief audio input detect stop
* 
* @param[in] card: card number
* @param[in] type: detect type
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_detect_stop(INT32_T card, TKL_MEDIA_DETECT_TYPE_E type)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_MEDIA_DETECT_TYPE_E type);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_detect_stop));

    if(fun) {
        ret = fun(card, type);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief audio detect get result
* 
* @param[in] card: card number
* @param[in] type: detect type
* @param[out] presult: audio detect result
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_ai_detect_get_result(INT32_T card, TKL_MEDIA_DETECT_TYPE_E type, TKL_AUDIO_DETECT_RESULT_T *presult)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T card, TKL_MEDIA_DETECT_TYPE_E type, TKL_AUDIO_DETECT_RESULT_T *presult);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_ai_detect_get_result));

    if(fun) {
        ret = fun(card, type, presult);
    }

    return ret;
    // --- END: user implements ---
}

