/**
 * @file tkl_cellular_base.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_cellular_base.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief sim卡状态变化通知函数原型
 * @param state sim卡状态，查看 @TAL_SIM_STATE_E 定义
 */

OPERATE_RET tkl_cellular_base_init(TKL_CELL_INIT_PARAM_T *param)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_CELL_INIT_PARAM_T *param);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_init));

    if(fun) {
        ret = fun(param);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取当前设备的通讯能力
 * @param ability @TKL_CELLULAR_ABILITY_E 类型
 * @return 0 成功  其它 失败
 */

OPERATE_RET tkl_cellular_base_get_ability(TKL_CELLULAR_ABILITY_E *ability)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_CELLULAR_ABILITY_E *ability);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_ability));

    if(fun) {
        ret = fun(ability);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 切换当前使能的SIM卡。
 * @param simid SIM卡ID.(0~1)
 * @return 0 成功  其它 失败
 */

OPERATE_RET tkl_cellular_base_switch_sim(UINT8_T sim_id)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_switch_sim));

    if(fun) {
        ret = fun(sim_id);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 注册SIM状态变化通知函数
 * @param fun 状态变化通知函数
 * @return 0 成功  其它 失败
 */

OPERATE_RET tkl_cellular_base_register_sim_state_notify(UINT8_T simd_id,TKL_SIM_NOTIFY fun)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T simd_id,TKL_SIM_NOTIFY fun);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T func;

    func = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_register_sim_state_notify));

    if(fun) {
        ret = func(simd_id, fun);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 使能或禁止sim卡热拔插
 *
 * @param simId sim卡ID
 * @param enable TRUE 使能 FALSE 禁止
 *
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_enable_sim_hotplug(UINT8_T sim_id, BOOL_T enable)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id, BOOL_T enable);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_enable_sim_hotplug));

    if(fun) {
        ret = fun(sim_id, enable);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取SIM卡的状态
 * @param simId sim卡ID
 * @param state 1：正常，0：异常，2：初始化中
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_sim_get_status(UINT8_T sim_id, UCHAR_T *state)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id, UCHAR_T *state);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_sim_get_status));

    if(fun) {
        ret = fun(sim_id, state);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取蜂窝设备当前的通信功能设置
 *
 * @param cfun 获取的通信功能
 *
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_cfun_mode(UINT8_T simd_id,PINT_T cfun)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T simd_id,PINT_T cfun);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_cfun_mode));

    if(fun) {
        ret = fun(simd_id, cfun);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置蜂窝设备的通信功能模式
 *
 * @param cfun 通信功能，取值含义如下：
 *            1：全功能模式
 *            4：飞行模式
 *
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_set_cfun_mode(UINT8_T simd_id,INT_T cfun)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T simd_id,INT_T cfun);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_set_cfun_mode));

    if(fun) {
        ret = fun(simd_id, cfun);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取SIM卡中的国际移动用户识别码
 *
 * @param simid,SIM卡id号(0,1,2...)
 * @param imsi识别码，为16字节的字符串
 *
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_imsi(UINT8_T sim_id,CHAR_T imsi[15 + 1])
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id,CHAR_T imsi[15 + 1]);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_imsi));

    if(fun) {
        ret = fun(sim_id, imsi);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取SIM卡的ICCID
 * @param simid
 * @param ICCID识别码，为20字节的字符串
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_iccid (UINT8_T sim_id,CHAR_T iccid[20 + 1])
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T) (UINT8_T sim_id,CHAR_T iccid[20 + 1]);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_iccid));

    if(fun) {
        ret = fun(sim_id, iccid);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取SIM卡所在通道设备的IMEI号
 * @param simid
 * @param IMEI识别码，为15字节的字符串
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_imei (UINT8_T sim_id,CHAR_T imei[15 + 1])
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T) (UINT8_T sim_id,CHAR_T imei[15 + 1]);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_imei));

    if(fun) {
        ret = fun(sim_id, imei);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置设备的IMEI号
 * @param simid
 * @param IMEI识别码，为15字节的字符串
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_set_imei (UINT8_T sim_id,CHAR_T imei[15 + 1])
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T) (UINT8_T sim_id,CHAR_T imei[15 + 1]);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_set_imei));

    if(fun) {
        ret = fun(sim_id, imei);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取SIM卡所在通道蜂窝设备的信号接收功率——单位dbm
 * @param simid
 * @param rsrp 返回实际的信号强度(dbm)
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_rsrp(UINT8_T sim_id,INT_T *rsrp)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id,INT_T *rsrp);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_rsrp));

    if(fun) {
        ret = fun(sim_id, rsrp);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取蜂窝设备SIM卡所在通道的信号噪声比及误码率
 * @param simid
 * @param sinr (0~31)
 * @param bit_error (0~7,99) 99无网络
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_sinr(UINT8_T sim_id,INT_T *sinr,INT_T *bit_error)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id,INT_T *sinr,INT_T *bit_error);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_sinr));

    if(fun) {
        ret = fun(sim_id, sinr, bit_error);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief SIM卡所在通道LBS的基站信息)
 * @param simid
 * @param lbs 返回基站信息
 * @param neighbour 是否搜索临近基站信息
 * @param timeout 搜索临近基站信息超时时间(一般需要4秒左右)
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_get_lbs(UINT8_T sim_id,TKL_LBS_INFO_T *lbs,BOOL_T neighbour,INT_T timeout)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id,TKL_LBS_INFO_T *lbs,BOOL_T neighbour,INT_T timeout);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_lbs));

    if(fun) {
        ret = fun(sim_id, lbs, neighbour, timeout);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取当前设备的射频校准状态
 * @param
 * @return TRUE正常，FALSE异常
 */

BOOL_T tkl_cellular_base_rf_calibrated(VOID_T)
{
    // --- BEGIN: user implements ---
    typedef BOOL_T (*TYPE_T)(VOID_T);

    BOOL_T ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_rf_calibrated));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 使能或禁止sim卡gpio检测
 *
 * @param simId sim卡ID
 * @param enable TRUE 使能 FALSE 禁止
 *
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_enable_sim_detect(UINT8_T simid, BOOL_T enable)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T simid, BOOL_T enable);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_enable_sim_detect));

    if(fun) {
        ret = fun(simid, enable);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取默认的SIM ID
 *
 *
 * @return 小于0失败，其他SIM ID
 */

INT8_T tkl_cellular_base_get_default_simid(VOID)
{
    // --- BEGIN: user implements ---
    typedef INT8_T (*TYPE_T)(VOID);

    INT8_T ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_get_default_simid));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 蜂窝基础的通用控制功能，一般作为平台提供一些特殊的能力接口
 *
 * @param cmd 参考CELL_IOCTRL_CMD
 * @param argv 平台自定义
 *
 * @return 0 成功 其它 失败
 */

OPERATE_RET tkl_cellular_base_ioctl(INT_T cmd,VOID* argv)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT_T cmd,VOID* argv);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_base_ioctl));

    if(fun) {
        ret = fun(cmd, argv);
    }

    return ret;
    // --- END: user implements ---
}

