/**
 * @file tkl_cellular_call.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_cellular_call.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief 查询呼叫服务是否可用
 * @note 该函数用于查询呼叫服务是否可用，只有在呼叫服务可用时，才能使用使用
 *       其它呼叫服务接口。
 *
 * @param simId sim卡ID
 *
 * @return 1 服务可用 0 服务不可用
 */

OPERATE_RET tkl_cellular_call_service_available(UINT8_T sim_id)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_service_available));

    if(fun) {
        ret = fun(sim_id);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 呼叫拨号接口函数
 *
 * @param simId sim卡ID号
 * @param callNUm 呼叫号码，字符串形式
 *
 * @return  0 发起呼叫成功 其它 失败
 */

OPERATE_RET tkl_cellular_call(UINT8_T sim_id, CHAR_T callNum[TKL_CELLULAR_CALLNUM_LEN_MAX])
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id, CHAR_T callNum[TKL_CELLULAR_CALLNUM_LEN_MAX]);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call));

    if(fun) {
        ret = fun(sim_id, callNum);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 外部呼叫到来时，应答接听接口函数
 *
 * @param 无
 *
 * @return   0 应答成功 其它 失败
 */

OPERATE_RET tkl_cellular_call_answer(UINT8_T sim_id)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_answer));

    if(fun) {
        ret = fun(sim_id);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 呼叫通话后，挂机接口函数
 *
 * @param 无
 *
 * @return  0 挂机成功 其它 失败
 */

OPERATE_RET tkl_cellular_call_hungup(UINT8_T sim_id)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_hungup));

    if(fun) {
        ret = fun(sim_id);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 注册用户定义的呼叫回调处理函数
 *
 * @param callback 呼叫回调处理函数
 *
 * @return 0 注册成功 其它 注册失败
 */

OPERATE_RET tkl_cellular_call_cb_register(TKL_CELLULAR_CALL_CB callback)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_CELLULAR_CALL_CB callback);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_cb_register));

    if(fun) {
        ret = fun(callback);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置呼入时铃声静音
 *
 * @param mute TRUE 静音 FALSE 非静音
 *
 * @return 0 设置成功 其它 设置失败
 */

OPERATE_RET tkl_cellular_call_set_callin_mute(BOOL_T mute)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T mute);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_set_callin_mute));

    if(fun) {
        ret = fun(mute);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 启动或者关闭volte功能
 *
 * @param enable TRUE启用volte,false关闭volte
 *
 * @return 0 设置成功 其它 设置失败
 */

OPERATE_RET tkl_cellular_call_set_volte(UINT8_T sim_id,BOOL_T enable)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id,BOOL_T enable);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_set_volte));

    if(fun) {
        ret = fun(sim_id, enable);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 播放电话的拨号音
 * @param tone 拨号音的特征值
 * @param duration 播放音的持续时间
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_play_tone(TUYA_TONE_TYPE_E tone, INT_T duration)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TUYA_TONE_TYPE_E tone, INT_T duration);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_play_tone));

    if(fun) {
        ret = fun(tone, duration);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 停止电话的拨号音
 * @param 无
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_stop_tone(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_stop_tone));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 将DTMF数字按键音频发送到语音通道
 * @note 1、该函数用于实现10086之类的语音交互，语音提示后，用户操作按键，调用该函数
 *       将按键音频发送到语音通道，该函数只能在通话状态后调用，否则将引起系统异常。
 *       2、dtmfTone只能是TKL_TONE_DTMF_0 ~ TKL_TONE_DTMF_STAR中的一种。
 *
 * @param dtmfTone 拨号按键
 * @param duration 音频持续时长
 *
 * @return 0 成功
 *        -1 dtmfTone 类型错误
 *        -2 分配内存失败
 *    OPRT_TIMEOUT 获取信号量超时
 *    OPRT_BASE_OS_ADAPTER_REG_NULL_ERROR 函数未适配
 */

OPERATE_RET tkl_cellular_call_dtmf2voice(TUYA_TONE_TYPE_E dtmfTone, UINT_T duration)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TUYA_TONE_TYPE_E dtmfTone, UINT_T duration);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_dtmf2voice));

    if(fun) {
        ret = fun(dtmfTone, duration);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置语音通话音频的音量
 * @param vol （0~100）
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_set_voice_vol(INT_T vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT_T vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_set_voice_vol));

    if(fun) {
        ret = fun(vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取语音通话音频的音量
 * @param vol （0~100）
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_get_voice_vol(PINT_T vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(PINT_T vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_get_voice_vol));

    if(fun) {
        ret = fun(vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 通话过程中，上行音频是否设置静音
 * When the current voice call is finished, the property will be kept.
 * 当前的语音呼叫结束后，这个属性会被保存下来。下次再进行语音通话的过程中，如果
 * 上次被设置为静音，则继续静音。但是重启后，会被默认恢复成非静音
 * @param TRUE for mute uplink of voice call
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_set_voice_mute(BOOL_T mute)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T mute);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_set_voice_mute));

    if(fun) {
        ret = fun(mute);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取通话过程中的上行声音的静音状态。
 * @param mute : TRUE 静音
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_get_voice_mute(PBOOL_T mute)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(PBOOL_T mute);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_get_voice_mute));

    if(fun) {
        ret = fun(mute);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 注册DMTF侦测回调函数
 * @param cb :  回调函数
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_reg_KTDetect(TKL_CELLULAR_CALL_KTDETECH_CB cb)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_CELLULAR_CALL_KTDETECH_CB cb);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_reg_KTDetect));

    if(fun) {
        ret = fun(cb);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 控制DTMF侦测功能是否使能，系统默认未使能。（开启这个功能，音频相关业务过程中，会增加系统负荷）
 * @param enable : TRUE 使能 FALSE 禁止
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_call_ctrl_KTDetect(BOOL_T enable)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T enable);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_call_ctrl_KTDetect));

    if(fun) {
        ret = fun(enable);
    }

    return ret;
    // --- END: user implements ---
}

