/**
 * @file tkl_cellular_keypad.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_cellular_keypad.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief init tuya cellular keypad service.
 *
 * @note
 *      if keypad service init failed, system will be crash.
 */

OPERATE_RET tkl_cellular_keypad_init(VOID *param)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID *param);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_keypad_init));

    if(fun) {
        ret = fun(param);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief add key event listener to keypad service.
 *
 * @param keyId   key id
 * @param cb      user defined key event callback function
 * @param ctx     argument for @cb
 * @return
 *        listener instance or NULL
 */

TUYA_CELLULAR_KEY_LISTENER tkl_cellular_keypad_key_listener_add(TUYA_KEYMAP_E keyId,TUYA_CELLULAR_KEY_CB cb,void *ctx)
{
    // --- BEGIN: user implements ---
    typedef TUYA_CELLULAR_KEY_LISTENER (*TYPE_T)(TUYA_KEYMAP_E keyId,TUYA_CELLULAR_KEY_CB cb,void *ctx);

    TUYA_CELLULAR_KEY_LISTENER ret = NULL;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_keypad_key_listener_add));

    if(fun) {
        ret = fun(keyId, cb, ctx);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief delete key event listener from keypad service.
 *
 * @param listener    listener to delete
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_cellular_keypad_key_listener_delete(TUYA_CELLULAR_KEY_LISTENER listener)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TUYA_CELLULAR_KEY_LISTENER listener);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_keypad_key_listener_delete));

    if(fun) {
        ret = fun(listener);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief get current key state.
 *
 * @param keyId[in]    key id
 * @param state[out]    @TUYA_KEYSTATE_E
 *     TUYA_KEY_PRESS   the key is pressed
 *     TUYA_KEY_RELEASE the key is released
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_cellular_keypad_key_state_get(TUYA_KEYMAP_E keyId,TUYA_KEYSTATE_E *state)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TUYA_KEYMAP_E keyId,TUYA_KEYSTATE_E *state);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_keypad_key_state_get));

    if(fun) {
        ret = fun(keyId, state);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief keypad ioctl.
 *
 * @param cmd
 * @param argv
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_cellular_keypad_key_ioctl(INT_T cmd,VOID *argv)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT_T cmd,VOID *argv);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_keypad_key_ioctl));

    if(fun) {
        ret = fun(cmd, argv);
    }

    return ret;
    // --- END: user implements ---
}

