/**
 * @file tkl_storage.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_storage.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief get internal r/w dir
 *
 * @param path absolute path returned on success
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_get_internal_dir(CHAR_T path[MAX_PATH_LEN])
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T path[MAX_PATH_LEN]);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_get_internal_dir));

    if(fun) {
        ret = fun(path);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief report filesystem disk space usage
 *
 * @param mount_path mount point
 * @param df fs state loaded on success
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_df(CHAR_T *mount_point, TKL_STORAGE_DF_T *df)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *mount_point, TKL_STORAGE_DF_T *df);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_df));

    if(fun) {
        ret = fun(mount_point, df);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief get one device info
 *
 * @param list device list loaded on success
 * @return OPERATE_RET return list number on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_get_device_info(CHAR_T *dev_name, TKL_STORAGE_DEVICE_INFO_T *list)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *dev_name, TKL_STORAGE_DEVICE_INFO_T *list);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_get_device_info));

    if(fun) {
        ret = fun(dev_name, list);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief get block device list
 *
 * @param list device list loaded on success
 * @param num list number
 * @return OPERATE_RET return list number on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_get_device_list(TKL_STORAGE_DEVICE_INFO_T *list, INT_T num)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_STORAGE_DEVICE_INFO_T *list, INT_T num);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_get_device_list));

    if(fun) {
        ret = fun(list, num);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief get partition info
 *
 * @param dev_name device node wanted to list
 * @param list partition list loaded on success
 * @param num list number
 * @return OPERATE_RET return list number on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_get_part_list(CHAR_T *dev_name, TKL_STORAGE_PART_INFO_T *list, INT_T num)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *dev_name, TKL_STORAGE_PART_INFO_T *list, INT_T num);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_get_part_list));

    if(fun) {
        ret = fun(dev_name, list, num);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief make partition. refer to parted/fdisk
 *
 * @param part_name partition label, optional
 * @param part_type partition type, eg. primary logical extended
 * @param fs_type filesystem type, eg. ext4 xfs, optional
 * @param isadd part is add or delet, 1:add, 2:delete
 * @param part_index means part number, eg. primary[1-4] logical [5 or over]
 * @param start partition start position, KB
 * @param end partition end position, KB
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_make_part(CHAR_T *part_name, CHAR_T *part_type,CHAR_T *fs_type, BOOL_T isadd, UINT_T part_index, LONG_T start, LONG_T end)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *part_name, CHAR_T *part_type,CHAR_T *fs_type, BOOL_T isadd, UINT_T part_index, LONG_T start, LONG_T end);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_make_part));

    if(fun) {
        ret = fun(part_name, part_type, fs_type, isadd, part_index, start, end);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief partiton format, build filesystem
 *
 * @param fs_type filesystem type, eg. ext4 fat32
 * @param fs_dev device node, eg. /dev/sda1
 * @param parm mkfs parame, eg. mkfs.vfat -F 32 -n "name" /dev/sda1
 * @param cb progress callback, optional
 * @param user_ctx caller's private context, optional
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_mkfs(CHAR_T *fs_type, CHAR_T *fs_dev, CHAR_T *parm,TKL_STORAGE_PROGRESS_CB cb, VOID *user_ctx)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *fs_type, CHAR_T *fs_dev, CHAR_T *parm,TKL_STORAGE_PROGRESS_CB cb, VOID *user_ctx);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_mkfs));

    if(fun) {
        ret = fun(fs_type, fs_dev, parm, cb, user_ctx);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief mount a filesystem partition. refer to mount system call
 *
 * @param source device node
 * @param target dir wanted mount to
 * @param fs_type filesystem type
 * @param flags filesystem r/w/a flags, optional
 * @param data filesystem-specific params, optional
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_mount(CHAR_T *source, CHAR_T *target,CHAR_T *fs_type, ULONG_T flags, VOID *data)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *source, CHAR_T *target,CHAR_T *fs_type, ULONG_T flags, VOID *data);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_mount));

    if(fun) {
        ret = fun(source, target, fs_type, flags, data);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief umount a filesystem partition. refer to umount system call
 *
 * @param target dir fs mounted
 * @param flags reserved flags
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_umount(CHAR_T *target, INT_T flags)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *target, INT_T flags);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_umount));

    if(fun) {
        ret = fun(target, flags);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief loop storage event, eg. hotplug
 * will not return except an error occured.
 *
 * @param event_cb callback handle storage event
 * @param user_ctx user private data, optional
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_loop_event(TKL_STORAGE_EVENT_CB event_cb, VOID *user_ctx)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_STORAGE_EVENT_CB event_cb, VOID *user_ctx);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_loop_event));

    if(fun) {
        ret = fun(event_cb, user_ctx);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief check and repair a filesystem
 *
 * @param blk_dev device node
 * @param fs_type filesystem type
 * @param parm fsck parame, eg. fsck.vfat -f /dev/sda1
 * @param flags reserved flags
 * @param cb progress callback, optional
 * @param user_ctx caller's private context, optional
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_fsck(CHAR_T *blk_dev, CHAR_T *fs_type, CHAR_T *parm, INT_T flags,TKL_STORAGE_PROGRESS_CB cb, VOID *user_ctx)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *blk_dev, CHAR_T *fs_type, CHAR_T *parm, INT_T flags,TKL_STORAGE_PROGRESS_CB cb, VOID *user_ctx);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_fsck));

    if(fun) {
        ret = fun(blk_dev, fs_type, parm, flags, cb, user_ctx);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief scsi generic ioctl
 *
 * @param dev_name device node name
 * @param request request. TODO: copy scsi header files for request
 * @param args args
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_ioctl(CHAR_T *dev_name, ULONG_T request, VOID *args)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *dev_name, ULONG_T request, VOID *args);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_ioctl));

    if(fun) {
        ret = fun(dev_name, request, args);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief check bad blocks
 *
 * @param dev_name device node name
 * @param cb callback to report bad blocks
 * @param user_ctx caller's private context, optional
 * @return OPERATE_RET 0 on success. A negative error code on error.
 */

OPERATE_RET tkl_storage_check_badblocks(CHAR_T *dev_name, TKL_STORAGE_BADBLK_CB cb, VOID *user_ctx)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CHAR_T *dev_name, TKL_STORAGE_BADBLK_CB cb, VOID *user_ctx);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_storage_check_badblocks));

    if(fun) {
        ret = fun(dev_name, cb, user_ctx);
    }

    return ret;
    // --- END: user implements ---
}

