/**
 * @file tkl_system.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_system.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief system enter critical
 *
 * @param[in]   none
 * @return  irq mask
 */

UINT_T tkl_system_enter_critical(VOID_T)
{
    // --- BEGIN: user implements ---
    typedef UINT_T (*TYPE_T)(VOID_T);

    UINT_T ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_enter_critical));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief system exit critical
 *
 * @param[in]   irq_mask: irq mask
 * @return  none
 */

VOID_T tkl_system_exit_critical(UINT_T irq_mask)
{
    // --- BEGIN: user implements ---
    typedef VOID_T (*TYPE_T)(UINT_T irq_mask);

    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_exit_critical));

    if(fun) {
         fun(irq_mask);
    }

    return;
    // --- END: user implements ---
}

/**
 * @brief system reset
 *
 * @param none
 *
 * @return none
 */

VOID_T tkl_system_reset(VOID_T)
{
    // --- BEGIN: user implements ---
    typedef VOID_T (*TYPE_T)(VOID_T);

    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_reset));

    if(fun) {
         fun();
    }

    return;
    // --- END: user implements ---
}

/**
 * @brief Get system tick count
 *
 * @param none
 *
 * @return system tick count
 */

SYS_TICK_T tkl_system_get_tick_count(VOID_T)
{
    // --- BEGIN: user implements ---
    typedef SYS_TICK_T (*TYPE_T)(VOID_T);

    SYS_TICK_T ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_get_tick_count));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Get system millisecond
 *
 * @param none
 *
 * @return system millisecond
 */

SYS_TIME_T tkl_system_get_millisecond(VOID_T)
{
    // --- BEGIN: user implements ---
    typedef SYS_TIME_T (*TYPE_T)(VOID_T);

    SYS_TIME_T ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_get_millisecond));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Get system random data
 *
 * @param[in] range: random from 0  to range
 *
 * @return random value
 */

INT_T tkl_system_get_random(UINT_T range)
{
    // --- BEGIN: user implements ---
    typedef INT_T (*TYPE_T)(UINT_T range);

    INT_T ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_get_random));

    if(fun) {
        ret = fun(range);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Get system reset reason
 *
 * @param[in] describe: point to reset reason describe
 *
 * @return reset reason
 */

TUYA_RESET_REASON_E tkl_system_get_reset_reason(CHAR_T** describe)
{
    // --- BEGIN: user implements ---
    typedef TUYA_RESET_REASON_E (*TYPE_T)(CHAR_T** describe);

    TUYA_RESET_REASON_E ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_get_reset_reason));

    if(fun) {
        ret = fun(describe);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  system sleep
 *
 * @param[in] describe: num ms
 *
 * @return none
 */

VOID_T tkl_system_sleep(UINT_T num_ms)
{
    // --- BEGIN: user implements ---
    typedef VOID_T (*TYPE_T)(UINT_T num_ms);

    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_sleep));

    if(fun) {
         fun(num_ms);
    }

    return;
    // --- END: user implements ---
}

/**
 * @brief system delay
 *
 * @param[in] msTime: time in MS
 *
 * @note This API is used for system sleep.
 *
 * @return VOID
 */

VOID_T tkl_system_delay(UINT_T num_ms)
{
    // --- BEGIN: user implements ---
    typedef VOID_T (*TYPE_T)(UINT_T num_ms);

    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_system_delay));

    if(fun) {
         fun(num_ms);
    }

    return;
    // --- END: user implements ---
}

