/**
 * @file tkl_thread.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_thread.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---



/**
* @brief Create thread
*
* @param[out] thread: thread handle
* @param[in] name: thread name
* @param[in] stack_size: stack size of thread
* @param[in] priority: priority of thread,please ref to tkl thread priority define in tuya_cloud_types.h
* @param[in] func: the main thread process function
* @param[in] arg: the args of the func, can be null
*
* @note This API is used for creating thread.
*
* @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
*/
OPERATE_RET tkl_thread_create(TKL_THREAD_HANDLE* thread,
                              CONST CHAR_T* name,
                              UINT_T stack_size,
                              UINT_T priority,
                              CONST THREAD_FUNC_T func,
                              VOID_T* CONST arg)
{

    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_THREAD_HANDLE* thread, CONST CHAR_T* name, 
		              UINT_T stack_size, UINT_T priority,
                              CONST THREAD_FUNC_T func, VOID_T* CONST arg);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_create));

    if(fun) {
        ret = fun(thread, name, stack_size, priority, func, arg);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Terminal thread and release thread resources
 *
 * @param[in] thread: thread handle
 *
 * @note This API is used to terminal thread and release thread resources.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_release(CONST TKL_THREAD_HANDLE thread)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CONST TKL_THREAD_HANDLE thread);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_release));

    if(fun) {
        ret = fun(thread);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Get the thread stack's watermark
 *
 * @param[in] thread: thread handle
 * @param[out] watermark: watermark in Bytes
 *
 * @note This API is used to get the thread stack's watermark.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_get_watermark(CONST TKL_THREAD_HANDLE thread, UINT_T* watermark)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CONST TKL_THREAD_HANDLE thread, UINT_T* watermark);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_get_watermark));

    if(fun) {
        ret = fun(thread, watermark);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Get the thread thread handle
 *
 * @param[out] thread: thread handle
 *
 * @note This API is used to get the thread handle.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_get_id(TKL_THREAD_HANDLE *thread)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_THREAD_HANDLE *thread);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_get_id));

    if(fun) {
        ret = fun(thread);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Set name of self thread
 *
 * @param[in] name: thread name
 *
 * @note This API is used to set name of self thread.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_set_self_name(CONST CHAR_T* name)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CONST CHAR_T* name);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_set_self_name));

    if(fun) {
        ret = fun(name);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Check thread is self thread
 *
 * @param[in] thread: thread handle
 * @param[out] is_self: is self thread or not
 *
 * @note This API is used to check thread is self thread.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_is_self(TKL_THREAD_HANDLE thread, BOOL_T* is_self)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_THREAD_HANDLE thread, BOOL_T* is_self);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_is_self));

    if(fun) {
        ret = fun(thread, is_self);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Get thread priority
 *
 * @param[in] thread: thread handle, If NULL indicates the current thread
 * @param[in] priority: thread priority
 *
 * @note This API is used to get thread priority.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_get_priority(TKL_THREAD_HANDLE thread, INT_T *priority)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_THREAD_HANDLE thread, INT_T *priority);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_get_priority));

    if(fun) {
        ret = fun(thread, priority);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Set thread priority
 *
 * @param[in] thread: thread handle, If NULL indicates the current thread
 * @param[in] priority: thread priority
 *
 * @note This API is used to Set thread priority.
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_set_priority(TKL_THREAD_HANDLE thread, INT_T priority)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_THREAD_HANDLE thread, INT_T priority);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_set_priority));

    if(fun) {
        ret = fun(thread, priority);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief Diagnose the thread(dump task stack, etc.)
 *
 * @param[in] thread: thread handle
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_thread_diagnose(TKL_THREAD_HANDLE thread)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_THREAD_HANDLE thread);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_thread_diagnose));

    if(fun) {
        ret = fun(thread);
    }

    return ret;
    // --- END: user implements ---
}

