/**
 * @file tkl_video_in.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_video_in.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief vi init
 *
 * @param[in] pconfig: vi config
 * @param[in] count: count of pconfig
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_init(TKL_VI_CONFIG_T *pconfig, INT32_T count)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CONFIG_T *pconfig, INT32_T count);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_init));

    if(fun) {
        ret = fun(pconfig, count);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief vi set mirror and flip
 *
 * @param[in] chn: vi chn
 * @param[in] flag: mirror and flip value
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_set_mirror_flip(TKL_VI_CHN_E chn, TKL_VI_MIRROR_FLIP_E flag)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_VI_MIRROR_FLIP_E flag);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_set_mirror_flip));

    if(fun) {
        ret = fun(chn, flag);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief vi get mirror and flip
 *
 * @param[in] chn: vi chn
 * @param[out] flag: mirror and flip value
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_get_mirror_flip(TKL_VI_CHN_E chn, TKL_VI_MIRROR_FLIP_E *flag)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_VI_MIRROR_FLIP_E *flag);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_get_mirror_flip));

    if(fun) {
        ret = fun(chn, flag);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief vi uninit
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_uninit(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_uninit));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  set sensor reg value
 *
 * @param[in] chn: vi chn
 * @param[in] pparam: reg info
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_sensor_reg_set( TKL_VI_CHN_E chn, TKL_VI_SENSOR_REG_CONFIG_T *parg)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)( TKL_VI_CHN_E chn, TKL_VI_SENSOR_REG_CONFIG_T *parg);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_sensor_reg_set));

    if(fun) {
        ret = fun(chn, parg);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  get sensor reg value
 *
 * @param[in] chn: vi chn
 * @param[in] pparam: reg info
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_sensor_reg_get( TKL_VI_CHN_E chn, TKL_VI_SENSOR_REG_CONFIG_T *parg)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_VI_SENSOR_REG_CONFIG_T *parg);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_sensor_reg_get));

    if(fun) {
        ret = fun(chn,parg);
    }

    return ret;
    // --- END: user implements ---
}


/**
* @brief detect init
* 
* @param[in] chn: vi chn
* @param[in] type: detect type
* @param[in] pconfig: config
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_vi_detect_init(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type, TKL_VI_DETECT_CONFIG_T *p_config)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type, TKL_VI_DETECT_CONFIG_T *p_config);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_detect_init));

    if(fun) {
        ret = fun(chn, type, p_config);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief detect start
 *
 * @param[in] chn: vi chn
 * @param[in] type: detect type
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_detect_start(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_detect_start));

    if(fun) {
        ret = fun(chn, type);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief detect stop
 *
 * @param[in] chn: vi chn
 * @param[in] type: detect type
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_detect_stop(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_detect_stop));

    if(fun) {
        ret = fun(chn, type);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief get detection results
 *
 * @param[in] chn: vi chn
 * @param[in] type: detect type
 * @param[out] presult: detection results
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_detect_get_result(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type, TKL_VI_DETECT_RESULT_T *presult)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type, TKL_VI_DETECT_RESULT_T *presult);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_detect_get_result));

    if(fun) {
        ret = fun(chn, type, presult);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief set detection param
 *
 * @param[in] chn: vi chn
 * @param[in] type: detect type
 * @param[in] pparam: detection param
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_vi_detect_set(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type, TKL_VI_DETECT_PARAM_T *pparam)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type, TKL_VI_DETECT_PARAM_T *pparam);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_detect_set));

    if(fun) {
        ret = fun(chn, type, pparam);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief detect uninit
* 
* @param[in] chn: vi chn
* @param[in] type: detect type
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_vi_detect_uninit(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E chn, TKL_MEDIA_DETECT_TYPE_E type);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_vi_detect_uninit));

    if(fun) {
        ret = fun(chn, type);
    }

    return ret;
    // --- END: user implements ---
}


