/**
 * @file tkl_cellular_player.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_cellular_player.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief 播放一个音频文件
 * @param type  audio 播放类型
 * 注意：当类型为TKL_AUDEV_PLAY_TYPE_VOICE时候，音频源只支持8K采样率，8bit/16bit/32bit,
 * 单声道。否则播放的声音异常
 * @param format    音频文件格式
 * @param file_path 音频文件（需要包含完整的路径）
 * @param cb        播放的事件回调函数
 * @param cb_ctx    回调函数的参数
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_start(TKL_AUDIO_PLAYER_TYPE_E type, TKL_AUDIO_STREAM_FORMAT_E format, PCHAR_T file_path,TKL_AUDIO_PLAYER_CB cb, PVOID_T cb_ctx)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDIO_PLAYER_TYPE_E type, TKL_AUDIO_STREAM_FORMAT_E format, PCHAR_T file_path,TKL_AUDIO_PLAYER_CB cb, PVOID_T cb_ctx);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_start));

    if(fun) {
        ret = fun(type, format, file_path, cb, cb_ctx);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 暂停正在播放的音频
 * @param 无
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_pause(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_pause));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 恢复暂停的的音频
 * @param 无
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_resume(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_resume));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 停止正在播放的的音频
 * @param 无
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_stop(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_stop));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置音频播放的音量
 * @param vol （0~100）
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_set_vol(INT_T vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT_T vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_set_vol));

    if(fun) {
        ret = fun(vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取音频播放的音量
 * @param vol （0~100）
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_get_vol(PINT_T vol)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(PINT_T vol);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_get_vol));

    if(fun) {
        ret = fun(vol);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置音频输出设备的是否静音。这个属性不会被保存到flash中。
 * 每次重启后，都会变成非静音
 * @param mute : TRUE 静音
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_set_mute(BOOL_T mute)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T mute);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_set_mute));

    if(fun) {
        ret = fun(mute);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取音频输出设备的是否静音。
 * @param mute : TRUE 静音
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_get_mute(PBOOL_T mute)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(PBOOL_T mute);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_get_mute));

    if(fun) {
        ret = fun(mute);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置音频输出设备
 * @param channle TKL_AUDEV_OUTPUT_TYPE
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_set_audio_output(TKL_AUDEV_OUTPUT_TYPE chan)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDEV_OUTPUT_TYPE chan);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_set_audio_output));

    if(fun) {
        ret = fun(chan);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取音频输出设备
 * @param channle TKL_AUDEV_OUTPUT_TYPE
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_get_audio_output(TKL_AUDEV_OUTPUT_TYPE *chan)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDEV_OUTPUT_TYPE *chan);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_get_audio_output));

    if(fun) {
        ret = fun(chan);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置音频输入设备
 * @param channle TKL_AUDEV_INPUT_TYPE
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_set_audio_input(TKL_AUDEV_INPUT_TYPE chan)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDEV_INPUT_TYPE chan);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_set_audio_input));

    if(fun) {
        ret = fun(chan);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取音频输入设备
 * @param channle TKL_AUDEV_INPUT_TYPE
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_get_audio_input(TKL_AUDEV_INPUT_TYPE *chan)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDEV_INPUT_TYPE *chan);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_get_audio_input));

    if(fun) {
        ret = fun(chan);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取音频当前的播放状态
 * @param status TKL_AUDIO_PLAYER_STATUS_E
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_get_status(TKL_AUDIO_PLAYER_STATUS_E *status)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_AUDIO_PLAYER_STATUS_E *status);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_get_status));

    if(fun) {
        ret = fun(status);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 停止流媒体播放
 *
 * @return 0 成功，其他失败
 */

OPERATE_RET tkl_cellular_player_stop_stream(VOID)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(VOID);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_player_stop_stream));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

