/**
 * @file tkl_cellular_sms.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_cellular_sms.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief 发送短信
 *
 * @param simId sim卡ID
 * @param smsMsg 发送的短信
 *
 * @return  0 发送成功 其它 发送失败
 */

OPERATE_RET tkl_cellular_sms_send(UINT8_T sim_id, TUYA_CELLULAR_SMS_SEND_T* sms_msg)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T sim_id, TUYA_CELLULAR_SMS_SEND_T* sms_msg);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_sms_send));

    if(fun) {
        ret = fun(sim_id, sms_msg);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 注册短信接收回调函数
 * @note 该函数需在SIM卡激活前注册，否则可能引起异常或短信丢失。
 *
 * @param callback 短信接收回调函数
 *
 * @return  0 注册成功 其它 注册失败
 */

OPERATE_RET tkl_cellular_sms_recv_cb_register(TUYA_CELLULAR_SMS_CB callback)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TUYA_CELLULAR_SMS_CB callback);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_sms_recv_cb_register));

    if(fun) {
        ret = fun(callback);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置短信接收时静音
 * @note 默认情况下，收到短信时，会通过扬声器播放提示音。通过该函数，可设置接收
 *       短信时，不播放提示音。
 *
 * @param mute TRUE 静音 FALSE 短信接收时打开提示音
 *
 * @return 0 设置成功 其它 设置失败
 */

OPERATE_RET tkl_cellular_sms_mute(BOOL_T mute)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T mute);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_sms_mute));

    if(fun) {
        ret = fun(mute);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * 短信内容编码转换
 *
 * When a from_charset or a to_charset is unknown or unsupported,
 * return NULL.
 * The returned pointer is allocated inside, caller should free it.
 *
 * At most a from_size byte count will be processed. When a from_size
 * is -1, process till null chracter.
 *
 * null character will always be inserted into the output string.
 * Invalid characters are replaced silently.
 *
 * a to_size can be NULL in case that the output byte count is not needed.
 *
 * @param from          input string
 * @param from_size     input string byte count
 * @param from_chset    input string charset
 * @param to_chset      output string charset
 * @param to_size       output string byte count
 * @return
 *      - NULL: invalid parameters
 *      - output string
 */

VOID* tkl_cellular_sms_convert_str(CONST VOID *from, INT_T from_size,TUYA_CELLULAR_SMS_ENCODE_E from_chset, TUYA_CELLULAR_SMS_ENCODE_E to_chset, INT_T *to_size)
{
    // --- BEGIN: user implements ---
    typedef VOID* (*TYPE_T)(CONST VOID *from, INT_T from_size,TUYA_CELLULAR_SMS_ENCODE_E from_chset, TUYA_CELLULAR_SMS_ENCODE_E to_chset, INT_T *to_size);

    VOID* ret = NULL;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_sms_convert_str));

    if(fun) {
        ret = fun(from, from_size, from_chset, to_chset, to_size);
    }

    return ret;
    // --- END: user implements ---
}

