/**
 * @file tkl_cellular_vbat.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_cellular_vbat.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief 获取电池剩余电量百分比
 *
 * @param rsoc 剩余电量百分比
 *
 * @return OPRT_OK 获取成功 其它 获取失败
 */

OPERATE_RET tkl_cellular_vbat_get_rsoc(UINT8_T* rsoc)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT8_T* rsoc);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_get_rsoc));

    if(fun) {
        ret = fun(rsoc);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取电池电压
 *
 * @param voltage 当前电池电压，单位mV
 *
 * @return OPRT_OK 获取成功 其它 获取失败
 */

OPERATE_RET tkl_cellular_vbat_get_voltage(UINT_T* voltage)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT_T* voltage);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_get_voltage));

    if(fun) {
        ret = fun(voltage);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置是否开启NTC检测电池温度
 *
 * @param enable NTC检测电池温度开/关
 *
 * @return OPRT_OK 设置成功 其它 设置失败
 */

OPERATE_RET tkl_cellular_vbat_ntc_enable(BOOL_T enable)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T enable);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_ntc_enable));

    if(fun) {
        ret = fun(enable);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 设置恒流充电阶段，电池充电电流
 *
 * @param current 充电电流，单位毫安（mA)
 *
 * @return OPRT_OK 设置成功 其它 设置失败
 */

OPERATE_RET tkl_cellular_vbat_set_charge_current(UINT_T current)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(UINT_T current);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_set_charge_current));

    if(fun) {
        ret = fun(current);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 获取充电器状态
 *
 * @param 无
 *
 * @return 充电器状态，查看 @TKL_CELLULAR_VBAT_CHG_STATE_E定义
 */

TKL_CELLULAR_VBAT_CHG_STATE_E tkl_cellular_vbat_get_charger_state(VOID)
{
    // --- BEGIN: user implements ---
    typedef TKL_CELLULAR_VBAT_CHG_STATE_E (*TYPE_T)(VOID);

    TKL_CELLULAR_VBAT_CHG_STATE_E ret = 0;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_get_charger_state));

    if(fun) {
        ret = fun();
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 注册电池及充电器消息回调处理函数
 *
 * @param callback 回调函数
 *
 * @return 0 注册成功 其它 注册失败
 */

OPERATE_RET tkl_cellular_vbat_cb_register(TKL_CELLULAR_VBAT_CHARGE_CB callback)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_CELLULAR_VBAT_CHARGE_CB callback);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_cb_register));

    if(fun) {
        ret = fun(callback);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief 是否开启电池低电压关机功能
 *
 * @param enable TRUE 开启，FLASE关闭
 *
 * @return OPRT_OK 设置成功 其它 设置失败
 */

OPERATE_RET tkl_cellular_vbat_low_volt_poweroff_enable(BOOL_T enable)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(BOOL_T enable);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_cellular_vbat_low_volt_poweroff_enable));

    if(fun) {
        ret = fun(enable);
    }

    return ret;
    // --- END: user implements ---
}

