/**
 * @file tkl_video_enc.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_video_enc.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief video encode init
 *
 * @param[in] vi_chn: vi channel number
 * @param[in] pconfig: venc config
 * @param[in] count: count of pconfig
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_init(INT32_T vi_chn, TKL_VENC_CONFIG_T *pconfig, INT32_T count)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(INT32_T vi_chn, TKL_VENC_CONFIG_T *pconfig, INT32_T count);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_init));

    if(fun) {
        ret = fun(vi_chn, pconfig, count);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief video encode get frame
 *
 * @param[in] vi_chn: vi channel number
 * @param[in] venc_chn: venc channel number
 * @param[out] pframe:  output frame
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_get_frame(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_FRAME_T *pframe)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_FRAME_T *pframe);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_get_frame));

    if(fun) {
        ret = fun(vi_chn, venc_chn, pframe);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief video first snap
 *
 * @param[in] vi_chn: vi channel number
 * @param[out] pframe: output frame
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_get_first_snap(TKL_VI_CHN_E vi_chn, TKL_VENC_FRAME_T *pframe)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn, TKL_VENC_FRAME_T *pframe);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_get_first_snap));

    if(fun) {
        ret = fun(vi_chn, pframe);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief video encode set osd
 *
 * @param[in] vi_chn: vi channel number
 * @param[in] venc_chn: venc channel number
 * @param[out] posd:  osd config
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_set_osd(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_OSD_T *posd)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn,  TKL_VENC_OSD_T *posd);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_set_osd));

    if(fun) {
        ret = fun(vi_chn, venc_chn, posd);
    }

    return ret;
    // --- END: user implements ---
}

/**
* @brief video encode set mask
* 
* @param[in] vi_chn: vi channel number
* @param[in] venc_chn: venc channel number
* @param[out] pmask: mask config
*
* @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
*/
OPERATE_RET tkl_venc_set_mask(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_MASK_T *pmask)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_MASK_T *pmask);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_set_mask));

    if(fun) {
        ret = fun(vi_chn, venc_chn, pmask);
    }

    return ret;
    // --- END: user implements ---


}



/**
 * @brief video encode stream buff pool set
 *
 * @param[in] vi_chn: vi channel number
 * @param[in] venc_chn: venc channel number
 * @param[in] parg:  buff pool config
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_set_video_stream_buffer(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_STREAM_BUFF_T *parg)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn, TKL_VENC_STREAM_BUFF_T *parg);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_set_video_stream_buffer));

    if(fun) {
        ret = fun(vi_chn, venc_chn, parg);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief video encode  start
 *
 * @param[in] vi_chn: vi channel number
 * @param[in] venc_chn: venc channel number
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_start(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_start));

    if(fun) {
        ret = fun(vi_chn, venc_chn);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief video encode  stop
 *
 * @param[in] vi_chn: vi channel number
 * @param[in] venc_chn: venc channel number
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_stop( TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)( TKL_VI_CHN_E vi_chn, TKL_VENC_CHN_E venc_chn);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_stop));

    if(fun) {
        ret = fun(vi_chn, venc_chn);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief video encode uninit
 *
 * @param[in] vi_chn: vi channel number
 *
 * @return OPRT_OK on success. Others on error, please refer to tkl_error_code.h
 */

OPERATE_RET tkl_venc_uninit(TKL_VI_CHN_E vi_chn)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_VI_CHN_E vi_chn);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_venc_uninit));

    if(fun) {
        ret = fun(vi_chn);
    }

    return ret;
    // --- END: user implements ---
}

