/**
 * @file tkl_wired.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 *
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 *
 */

// --- BEGIN: user defines and implements ---
#include "tkl_wired.h"
#include "tuya_error_code.h"
#include "tkl_adapter.h"

// --- END: user defines and implements ---

/**
 * @brief  get the link status of wired link
 *
 * @param[out]  is_up: the wired link status is up or not
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_wired_get_status(TKL_WIRED_STAT_E *status)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_WIRED_STAT_E *status);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_wired_get_status));

    if(fun) {
        ret = fun(status);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  set the status change callback
 *
 * @param[in]   cb: the callback when link status changed
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_wired_set_status_cb(TKL_WIRED_STATUS_CHANGE_CB cb)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(TKL_WIRED_STATUS_CHANGE_CB cb);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_wired_set_status_cb));

    if(fun) {
        ret = fun(cb);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  get the ip address of the wired link
 *
 * @param[in]   ip: the ip address
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_wired_get_ip(NW_IP_S *ip)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(NW_IP_S *ip);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_wired_get_ip));

    if(fun) {
        ret = fun(ip);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  get the mac address of the wired link
 *
 * @param[in]   mac: the mac address
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_wired_get_mac(NW_MAC_S *mac)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(NW_MAC_S *mac);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_wired_get_mac));

    if(fun) {
        ret = fun(mac);
    }

    return ret;
    // --- END: user implements ---
}

/**
 * @brief  set the mac address of the wired link
 *
 * @param[in]   mac: the mac address
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */

OPERATE_RET tkl_wired_set_mac(CONST NW_MAC_S *mac)
{
    // --- BEGIN: user implements ---
    typedef OPERATE_RET (*TYPE_T)(CONST NW_MAC_S *mac);

    OPERATE_RET ret = OPRT_NOT_SUPPORTED;
    TYPE_T fun;

    fun = (TYPE_T)tkl_adapt_func_get(FUNC_NAME(tkl_wired_set_mac));

    if(fun) {
        ret = fun(mac);
    }

    return ret;
    // --- END: user implements ---
}

